/**
 * @file
 * Mirotalk Sfu behaviors.
 */
(function ($, Drupal) {
  'use strict';
  Drupal.behaviors.mirotalkSfuMirotalkSfu = {
    attach(context) {
      once('body', '.mirotalk-project', context).forEach(function () {
        // @todo get url of site
        $('.create-room-project').on('click', function () {
          const data = drupalSettings.mirotalk_sfu;

          $.ajax({
            url: data.url,
            method: 'POST',
            data: data,
            success: function (response) {
              if (response.success) {
                window.open(response.meeting_url, '_blank');
              } else {
                alert('Error: ' + (response.message || 'Unknown error.'));
              }
            },
          });
        });
      });

      once('body', '.list-room', context).forEach(function () {
        // @todo get url of site
        let url_meeting = '/api/create-meeting';

        $('.generate-room').on('click', function () {
          function generateRandomString() {
            const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
            const getRandomChar = () => characters.charAt(Math.floor(Math.random() * characters.length));
            const part1 = Array.from({ length: 3 }, getRandomChar).join('');
            const part2 = Array.from({ length: 4 }, getRandomChar).join('');
            const part3 = Array.from({ length: 3 }, getRandomChar).join('');
            return `${part1}-${part2}-${part3}`;
          }
          $('#meeting-room-id').val(generateRandomString());
        });

        $('.create-room').on('click', function () {
          const data = drupalSettings.create_room;
          data.room_id = $('#meeting-room-id').val().normalize('NFD').replace(/[\u0300-\u036f]/g, '').replace(/\s+/g, '-');

          $.ajax({
            url: data.url,
            method: 'POST',
            data: data,
            success: function (response) {
              if (response.success) {
                window.open(response.meeting_url, '_blank');
              } else {
                alert('Error: ' + (response.message || 'Unknown error.'));
              }
            },
          });
        });
      });
    }
  };

}(jQuery, Drupal));
