<?php

namespace Drupal\mirotalk_sfu\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Attribute\FieldFormatter;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Plugin implementation of the 'button_join_room'.
 */
#[FieldFormatter(
  id: 'list_user_meeting',
  label: new TranslatableMarkup('List user'),
  description: new TranslatableMarkup('List user for meeting'),
  field_types: [
    'json',
  ],
)]
class MirotalkSfuFormatterUser extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $list = [];
    $value = $items->getValue();

    if (count($value) > 0) {
      $list = json_decode($value[0]['value'], TRUE);
    }

    return [
      '#theme' => 'list_user',
      "#data" => $list,
      "#base_path" => base_path(),
    ];
  }

}
